GUI <-
function(){
library(tcltk2)
library(tkrplot)
tclRequire("Tktable")
analytenumber<<-1
samplenumber<<-1
direct<<-0
saved.tab<<-0
defarray<<-0
sampleID<<-"sample"
was.normalized<<-0
tcl("tk_setPalette","white")
mainmenu <<- tktoplevel(width=1200, height=900)#
topMenu <- tkmenu(mainmenu)           # Create a menu
tkconfigure(mainmenu, menu = topMenu) # Add it to the 'tt' window


########################################################################################
#create the Optionsmenu
fileMenu <- tkmenu(topMenu, tearoff = FALSE)

tkadd(fileMenu, "command", label = "Set working directory", command = function(){ 	setwd(tclvalue(tkchooseDirectory(title="Please choose the working directory!")))
										Separation()
										direct<<-1
										})
tkadd(fileMenu, "command", label = "Define array layout", command = function(){
						if(direct!=1){						
						tkmessageBox(title = "Error",message = "Please choose working directory first!\n", icon = "error", type = "ok")
						}else{
						fileName <- tclvalue(tkgetOpenFile())
						namen=read.table(fileName,header=T,sep="\t")[,"Substance"]
						counter=1
						
						for(i in 1:length(namen)){
							
							if(i==1){
								analyte.names=as.character(namen[i])
								
							}else{
								if(length(which(analyte.names==as.character(namen[i])))==0){analyte.names=c(analyte.names,as.character(namen[i]))}
								
							}
							counter=counter+1
						}
						assign("analyte.names", sort(analyte.names), envir=.GlobalEnv)
						tkraise(mainmenu)
						tkfocus(mainmenu)
						defarray<<-1
						}
					}) 
tkadd(fileMenu, "command", label = "Quit", command = function() tkdestroy(mainmenu))

tkadd(topMenu, "cascade", label = "General", menu = fileMenu)


########################################################################################
#create the Calibrationmenu

calibrationMenu <- tkmenu(topMenu, tearoff = FALSE)

tkadd(calibrationMenu, "command", label = "Define calibration settings", command = function(){
					if(direct!=1){						
						tkmessageBox(title = "Error",message = "Please choose working directory first!\n", icon = "error", type = "ok")
						}else{
							if(defarray!=1){
								tkmessageBox(title = "Error",message = "Please define the array layout first!\n", icon = "error", type = "ok")
							}else{
						calibrationsettings()
					tkraise(mainmenu)
					tkfocus(mainmenu)
							}	}
					}) 
					
tkadd(calibrationMenu, "command", label = "Start calibration", command = function(){ 	
if(direct!=1){						
						tkmessageBox(title = "Error",message = "Please choose working directory first!\n", icon = "error", type = "ok")
						}else{
							if(defarray!=1){
								tkmessageBox(title = "Error",message = "Please define the array layout first!\n", icon = "error", type = "ok")
							}else{
								workpath=tclvalue(tkchooseDirectory(title="Please choose a directory with calibration data!"))
											analyte=analyte.choice(analyte.names)
											calID=textstring.entry.window("KOMA: Calibration replicate","Enter calibration replicate ID","")

											data=extractdata_strips(workpath
														,analyte
														,calID
														,times,concentrations)
											convalues=extractconfidence_strips(workpath
														,analyte
														,calID
														,times,concentrations)
											IDs.to.go.on=plotting.timecourses.and.choose.IDs.manually(data,analyte,convalues)
											
											
											calibration=collect.and.save.cal(data,IDs.to.go.on,analyte,calID)
											tkmessageBox(title = "Information",message = "Calibration file has been created successfully!\n", icon = "info", type = "ok")
											
											
											assign("calibration", calibration, envir=.GlobalEnv)
											tkraise(mainmenu)
											tkfocus(mainmenu)
											}}
										})


tkadd(calibrationMenu, "command", label = "Estimate mean calibration surface", command = function(){
							if(direct!=1){						
						tkmessageBox(title = "Error",message = "Please choose working directory first!\n", icon = "error", type = "ok")
						}else{
							if(defarray!=1){
								tkmessageBox(title = "Error",message = "Please define the array layout first!\n", icon = "error", type = "ok")
							}else{workpath=getwd()
							data.to.leeve.out=plotting.overlapping.cals(workpath)
							calculate.plot.mean.and.error(workpath,data.to.leeve.out)			
							tkmessageBox(title = "Information",message = "Calibration file has been created successfully!", icon = "info", type = "ok")
							tkraise(mainmenu)
							tkfocus(mainmenu)
							}}
							})
					

tkadd(topMenu, "cascade", label = "Calibration", menu = calibrationMenu)
########################################################################################
#create the Analysismenu

analyseMenu <- tkmenu(topMenu, tearoff = FALSE)



tkadd(analyseMenu, "command", label = "Analyze single sample", command = function(){ 	if(direct!=1){						
						tkmessageBox(title = "Error",message = "Please choose working directory first!\n", icon = "error", type = "ok")
						}else{
							if(defarray!=1){
								tkmessageBox(title = "Error",message = "Please define the array layout first!\n", icon = "error", type = "ok")
							}else{workpath=tclvalue(tkchooseDirectory(initialdir=wpath))
										analyte.local=analyte.choice(analyte.names)
										result=extractdata_unknown_predict_conc(workpath,analyte.local)
																			
										if(samplenumber>1){
											if(sampleID.local==sampleID){
												samplenumber=samplenumber-1
											}else{	
												
												for( i in 1:(analytenumber-1)){
																if(i==1){Vector=as.numeric(tclArray[(samplenumber-1),i])}else{Vector=c(Vector,as.numeric(tclArray[(samplenumber-1),i]))}
															}					 								 					
												mean.value=mean(Vector)
												
												STABW=sd(Vector)/((analytenumber-1)^(1/2))
												
												if(samplenumber==2  || hightroughput!=0){Zeile=c(Vector,mean.value,STABW)}else{Zeile=rbind(Zeile,c(Vector,mean.value,STABW))}
												tclArray[0,analytenumber]="mean.value"
												tclArray[samplenumber-1,analytenumber]=mean.value
												tclArray[0,analytenumber+1]="standarddeviation"
												tclArray[samplenumber-1,analytenumber+1]=STABW
												for( i in 1:(analytenumber+1)){
														if(i==1){Zeilennamen=as.character(tclArray[0,i])}else{Zeilennamen=c(Zeilennamen,as.numeric(tclArray[0,i]))}														
												}
												assign("Zeilennamen", Zeilennamen, envir=.GlobalEnv)
												assign("Zeile", Zeile, envir=.GlobalEnv)
												width.last.line=analytenumber-1
												analytenumber=1	
												assign("width.last.line", width.last.line, envir=.GlobalEnv)
											}
										}
										
										tclArray[samplenumber,0]=sampleID.local
										tclArray[samplenumber,analytenumber]=round(result,digits=3)
														
														
										tclArray[0,analytenumber]=gsub("[() .]","_",analyte.local)
										
										samplenumber=samplenumber+1
										analytenumber=analytenumber+1
										tkraise(mainmenu)
										tkfocus(mainmenu)
										assign("wpath", workpath, envir=.GlobalEnv)
										assign("samplenumber", samplenumber, envir=.GlobalEnv)
										assign("analytenumber", analytenumber, envir=.GlobalEnv)
										assign("analyte", analyte.local, envir=.GlobalEnv)
										assign("sampleID", sampleID.local, envir=.GlobalEnv)
										hightroughput<<-0
										}}
									})
									
tkadd(analyseMenu, "command", label = "Analyze batch of samples", command = function(){ 	
										if(direct!=1){						
						tkmessageBox(title = "Error",message = "Please choose working directory first!\n", icon = "error", type = "ok")
						}else{
							if(defarray!=1){
								tkmessageBox(title = "Error",message = "Please define the array layout first!\n", icon = "error", type = "ok")
							}else{workpath=tclvalue(tkchooseDirectory(initialdir=wpath))
										if(samplenumber>1){analyte.temp=analyte}
										analyte.local=analyte.choice(analyte.names)
										if(samplenumber>1){
											if(analyte.local!=analyte.temp){
												samplenumber=1										
											}	
												

										}
										
											
										
										paths=Sys.glob(file.path(workpath, "*")) 							#creates a list of folders inheriting the timepointsorted data
										paths=sort(paths)
										folders=list.dir(path =paths[1])
										
										progress=1
										total=length(folders)
										bar=tkProgressBar(title = "This process could take several seconds!", min = 0,max = total, width = 500)

										for(foldernames in folders){
										
										sampleID.local<<-foldernames
										result=extractdata_unknown_predict_conc_wholestrip(foldernames,paths,analyte.local,workpath)
																				
										if(samplenumber>1){
											if(analyte.local==analyte){
												analytenumber=analytenumber-1										
											}
											
										}
										
										tclArray[samplenumber,0]=gsub("[() .]","_",sampleID.local)										
										tclArray[samplenumber,analytenumber]=round(result,digits=3)
										tclArray[0,analytenumber]=gsub("[() .]","_",analyte.local)
										
										samplenumber=samplenumber+1
										analytenumber=analytenumber+1
										tkraise(mainmenu)
										tkfocus(mainmenu)
										assign("wpath", workpath, envir=.GlobalEnv)
										assign("samplenumber", samplenumber, envir=.GlobalEnv)
										assign("analytenumber", analytenumber, envir=.GlobalEnv)
										assign("sampleID", sampleID.local, envir=.GlobalEnv)
										setTkProgressBar(bar, progress, label=paste( "Analyzing samples!",round(progress/total*100,0),"% done"))
										
										progress=progress+1
										}
										close(bar)
										assign("analyte", analyte.local, envir=.GlobalEnv)
										tkmessageBox(title = "Information",message = "All folders analysed successfully!\n", icon = "info", type = "ok")
										hightroughput<<-1
										}}
									})

tkadd(topMenu, "cascade", label = "Analysis", menu = analyseMenu)


########################################################################################################################################################
#create tablemenu

fileMenu <- tkmenu(topMenu, tearoff = FALSE)

tkadd(fileMenu, "command", label = "Save table", command = function(){
				if(direct!=1){						
										tkmessageBox(title = "Error",message = "Please choose working directory first!\n", icon = "error", type = "ok")
										}else{
											if(defarray!=1){
												tkmessageBox(title = "Error",message = "Please define the array layout first!\n", icon = "error", type = "ok")
							}else{
				for(j in 1:(samplenumber-1)){
					for( i in 1:(analytenumber-1)){
							
							if(i==1){Vector=as.numeric(tclArray[j,i])
								}else{Vector=c(Vector,as.numeric(tclArray[j,i]))}
							
					}					
						if(hightroughput==0){
							mean.value=mean(Vector)
							STABW=sd(Vector)/((analytenumber-1)^(1/2))
							if(j==1){Zeile=c(Vector,mean.value,STABW)}else{Zeile=rbind(Zeile,c(Vector,mean.value,STABW))}
							tclArray[0,analytenumber]="mean.value"
							tclArray[samplenumber-1,analytenumber]=mean.value
							tclArray[0,analytenumber+1]="standarddeviation"
							tclArray[samplenumber-1,analytenumber+1]=STABW
						}else{
							if(j==1){Zeile=c(Vector)}else{Zeile=rbind(Zeile,c(Vector))}
						}
				}
					if(hightroughput==1){
						for( i in 1:(analytenumber-1)){
							if(i==1){Zeilennamen=as.character(tclArray[0,i])}else{Zeilennamen=c(Zeilennamen,as.character(tclArray[0,i]))}														
						}
					}else{
						for( i in 1:(analytenumber+1)){
							if(i==1){Zeilennamen=as.character(tclArray[0,i])}else{Zeilennamen=c(Zeilennamen,as.character(tclArray[0,i]))}														
						}
					}
					
					for(i in 0:(samplenumber-1)){
						if(i==0){reihenname=tclArray[i,0]}else{reihenname=c(reihenname,tclArray[i,0])}
					}
					
					table=cbind(reihenname,rbind(Zeilennamen,Zeile))
					
					if(is.vector(Zeile)){
						Zeile=t(Zeile)
						rownames(Zeile)=c(reihenname[-1])
						colnames(Zeile)=c(Zeilennamen)
					}else{
						rownames(Zeile)=c(reihenname[-1])
						colnames(Zeile)=c(Zeilennamen)
					}
					
					write.table(Zeile,file=paste(gsub("[()/?]","",analyte),"table.of.measurements.xls",sep="."),sep="\t",quote=FALSE,dec=",",row.names=T,col.names=T)
					saved.tab<<-1
					assign("table", Zeile, envir=.GlobalEnv)
					tkraise(mainmenu)
					tkfocus(mainmenu)
					}}
					}) 
tkadd(fileMenu, "command", label = "Save as table for normalization", command = function(){
					if(direct!=1){						
											tkmessageBox(title = "Error",message = "Please choose working directory first!\n", icon = "error", type = "ok")
											}else{
												if(defarray!=1){
													tkmessageBox(title = "Error",message = "Please define the array layout first!\n", icon = "error", type = "ok")
							}else{
					for( i in 1:(analytenumber-1)){
						if(i==1){Vector=as.numeric(tclArray[(samplenumber-1),i])}else{Vector=c(Vector,as.numeric(tclArray[(samplenumber-1),i]))}
						}	
					
					mean.value=mean(Vector)
					STABW=sd(Vector)/((analytenumber-1)^(1/2))
					if(samplenumber==2){Zeile=c(Vector,mean.value,STABW)}else{Zeile=rbind(Zeile,c(Vector,mean.value,STABW))}
					tclArray[0,analytenumber]="mean.value"
					tclArray[samplenumber-1,analytenumber]=mean.value
					tclArray[0,analytenumber+1]="standarddeviation"
					tclArray[samplenumber-1,analytenumber+1]=STABW
					
					
					for( i in 1:(analytenumber+1)){
						if(i==1){Zeilennamen=as.character(tclArray[0,i])}else{Zeilennamen=c(Zeilennamen,as.character(tclArray[0,i]))}														
					}
					
					for(i in 0:(samplenumber-1)){
						if(i==0){reihenname=tclArray[i,0]}else{reihenname=c(reihenname,tclArray[i,0])}
					}
					
					table=cbind(reihenname,rbind(Zeilennamen,Zeile))
					
					if(is.vector(Zeile)){
						Zeile=t(Zeile)
						rownames(Zeile)=c(reihenname[-1])
						colnames(Zeile)=c(Zeilennamen)
					}else{
						rownames(Zeile)=c(reihenname[-1])
						colnames(Zeile)=c(Zeilennamen)
					}
					
					save(Zeile,file=paste(gsub("[()/?]","",analyte),"table.for.normalization.RData",sep="."))
					assign("table.for.normalization", Zeile, envir=.GlobalEnv)
					tkraise(mainmenu)
					tkfocus(mainmenu)
					}}
					}) 
					

					
tkadd(fileMenu, "command", label = "Normalize table", command = function(){
				if(direct!=1){						
					tkmessageBox(title = "Error",message = "Please choose working directory first!\n", icon = "error", type = "ok")
				}else{
					if(defarray!=1){
						tkmessageBox(title = "Error",message = "Please define the array layout first!\n", icon = "error", type = "ok")
					}else{
						if(saved.tab==1 && file_test("-f",paste(gsub("[()/?]","",analyte),"table.of.measurements.xls",sep="."))){
							
							table=as.matrix(read.table(file=paste(gsub("[()/?]","",analyte),"table.of.measurements.xls",sep="."),dec=","))
							
								to.norm=c(table[,"mean.value"])
								fileName <- tclvalue(tkgetOpenFile())
								load(fileName)
								was.normalized=colnames(Zeile)[1]
								assign("was.normalized", was.normalized, envir=.GlobalEnv)
								for.norm=c(Zeile[,"mean.value"])
							if((length(to.norm))>=2 || (length(to.norm))==(length(for.norm))){
								for(i in 2:length(to.norm)){
									k=for.norm[i-1]/for.norm[i]
									tclArray[i-1,analytenumber]=to.norm[i]*k
									table[i-1,"mean.value"]=to.norm[i]*k
								}
								write.table(table,file=paste(gsub("[()/?]","",analyte),"table.of.normalized.measurements.xls",sep="."),sep="\t",quote=FALSE,dec=",",row.names=T,col.names=T)
								assign("table", table, envir=.GlobalEnv)
								tkmessageBox(title = "Information",message = "Table means have been normalized!", icon = "info", type = "ok")
							}else{
							tkmessageBox(title = "Error",message = "Current table and the table for normalization have to have to same size, but at least 2x2!\n", icon = "error", type = "ok")
							}
						}else{
							tkmessageBox(title = "Error",message = "Please save the table before normalizing!\n", icon = "error", type = "ok")
						}
						tkraise(mainmenu)
						tkfocus(mainmenu)
					}
				}
					}) 
tkadd(fileMenu, "command", label = "Plot table", command = function(){	
					if(direct!=1){						
						tkmessageBox(title = "Error",message = "Please choose working directory first!\n", icon = "error", type = "ok")
					}else{
						if(defarray!=1){
							tkmessageBox(title = "Error",message = "Please define the array layout first!\n", icon = "error", type = "ok")
							}else{
							require(utils)
							
					
					if(saved.tab==1 && file_test("-f",paste(gsub("[()/?]","",analyte),"table.of.measurements.xls",sep="."))){
						table=as.matrix(read.table(file=paste(gsub("[()/?]","",analyte),"table.of.measurements.xls",sep="."),dec=","))
						print(table)
					if(hightroughput==1){
						for(column in 1:ncol(table)){
							windows(20,20,title=colnames(table)[column])
							hh <- table[,column]
							if(was.normalized==0){
								mp<-barplot2(hh,names.arg=rownames(table), beside = TRUE,ylab="Analyte concentration [ng/ml]", ylim = c(0, 1.5*max(table[,column])),main = paste("Bar plot of",colnames(table)[column]), font.main = 4,cex.names = 0.8, plot.ci = F,plot.grid = TRUE,col=topo.colors(nrow(table)))
								
							}else{mp<-barplot2(hh,names.arg=rownames(table), beside = TRUE,ylab="Analyte concentration [ng/ml]", ylim = c(0, 1.5*max(table[,column])),sub=paste("Normalized by",was.normalized),main = paste("Bar plot of",colnames(table)[column]), font.main = 4,cex.names = 0.8, plot.ci = F,plot.grid = TRUE,col=topo.colors(nrow(table)))
								
							}
							#box()
							
						}
					}else{
						windows(20,20)
						hh <- table[,"mean.value"]
						ci.l <- table[,"mean.value"]+table[,"standarddeviation"]
						ci.u <- table[,"mean.value"]-table[,"standarddeviation"]
						if(was.normalized==0){mp <- barplot2(hh,names.arg=rownames(table), beside = TRUE,ylab="Analyte concentration [ng/ml]", ylim = c(0, 1.5*max(table[,"mean.value"])),main = paste("Bar plot of",analyte), font.main = 4,cex.names = 1.5, plot.ci = TRUE, ci.l = ci.l, ci.u = ci.u,plot.grid = TRUE,col=topo.colors(nrow(table)))
									
									}else{mp <- barplot2(hh,names.arg=rownames(table), beside = TRUE,ylab="Analyte concentration [ng/ml]", ylim = c(0, 1.5*max(table[,"mean.value"])),sub=paste("Nomalized by",was.normalized),main = paste("Bar plot of",analyte), font.main = 4,cex.names = 1.5, plot.ci = TRUE, ci.l = ci.l, ci.u = ci.u,plot.grid = TRUE,col=topo.colors(nrow(table)))
									
									}
						box()
					}
					tkraise(mainmenu)
					tkfocus(mainmenu)
					}else{
						tkmessageBox(title = "Error",message = "Please save the table before plotting!\n", icon = "error", type = "ok")
					}
					}}
					}) 
tkadd(fileMenu, "command", label = "Erase last step", command = function(){
					if(direct!=1){						
											tkmessageBox(title = "Error",message = "Please choose working directory first!\n", icon = "error", type = "ok")
											}else{
												if(defarray!=1){
													tkmessageBox(title = "Error",message = "Please define the array layout first!\n", icon = "error", type = "ok")
							}else{
					if((analytenumber-1)>0){
						tclArray[samplenumber-1,analytenumber-1]="deleted"
						analytenumber=analytenumber-1
					}else{
						tclArray[samplenumber-1,analytenumber-1]="deleted"
						samplenumber=samplenumber-2
						analytenumber=width.last.line
					}
					tclArray[0,0]="Estimated_concentrations_ng_per_ml"
					assign("analytenumber", analytenumber, envir=.GlobalEnv)
					assign("samplenumber", samplenumber, envir=.GlobalEnv)
					tkraise(mainmenu)
					tkfocus(mainmenu)
					}}
					}) 
					
tkadd(fileMenu, "command", label = "Erase last line", command = function(){
if(direct!=1){						
						tkmessageBox(title = "Error",message = "Please choose working directory first!\n", icon = "error", type = "ok")
						}else{
							if(defarray!=1){
								tkmessageBox(title = "Error",message = "Please define the array layout first!\n", icon = "error", type = "ok")
							}else{
					for(i in 0:(analytenumber-1)){
						tclArray[samplenumber-1,i]="deleted"
					}
					analytenumber=width.last.line
					samplenumber=samplenumber-2
					tclArray[0,0]="Estimated_concentrations_ng_per_ml"
					assign("analytenumber", analytenumber, envir=.GlobalEnv)
					assign("samplenumber", samplenumber, envir=.GlobalEnv)
					tkraise(mainmenu)
					tkfocus(mainmenu)	
					}}
					}) 
					
tkadd(fileMenu, "command", label = "Erase whole table", command = function(){
if(direct!=1){						
						tkmessageBox(title = "Error",message = "Please choose working directory first!\n", icon = "error", type = "ok")
						}else{
							if(defarray!=1){
								tkmessageBox(title = "Error",message = "Please define the array layout first!\n", icon = "error", type = "ok")
							}else{
					for(j in 0:samplenumber-1){
						for(i in 0:(analytenumber+1)){
							tclArray[j,i]="deleted"
						}
					}
					tclArray[0,0]="Estimated_concentrations_ng_per_ml"
					
					analytenumber=1
					samplenumber=1
					
					assign("analytenumber", analytenumber, envir=.GlobalEnv)
					assign("samplenumber", samplenumber, envir=.GlobalEnv)
					tkraise(mainmenu)
					tkfocus(mainmenu)
					}}
						
					}) 
tkadd(topMenu, "cascade", label = "Table Menu", menu = fileMenu)
########################################################################################
#create the Optionsmenu
fileMenu <- tkmenu(topMenu, tearoff = FALSE)


tkadd(fileMenu, "command", label = "Users guide", command = function() browseURL(system.file("doc","Usersguide.pdf",package="KOMA"))
)
tkadd(fileMenu, "command", label = "Manual of functions", command = function() browseURL(system.file("doc","KOMA-manual.pdf",package="KOMA"))
)
tkadd(topMenu, "cascade", label = "Manuals", menu = fileMenu)

####################################################################################################################################################
#define some needed functions
							
tclArrayVar <- function()
{
    n <- evalq(TclVarCount <- TclVarCount + 1, .TkRoot$env)
    name <- paste("::RTcl", n,sep = "")
    l <- list(env = new.env())
    assign(name, NULL, envir = l$env)
    reg.finalizer(l$env, function(env) tkcmd("unset", ls(env)))
    class(l) <- "tclArrayVar"
    .Tcl(paste("set ",name,"(0,0) \"\"",sep=""))
    l
}

assign("[.tclArrayVar",
function(object, i, j) {
  tclArrayName <- ls(object$env)
  tclvalue(paste(tclArrayName,"(",i,",",j,")",sep=""))
})

assign("[<-.tclArrayVar",
function(object, i,j,value) {
  tclArrayName <- ls(object$env)
  .Tcl(paste("set ",tclArrayName,"(",i,",",j,") ",value,sep=""))  
  return(object)
})


tclArray <- tclArrayVar()
tclArrayName <- ls(tclArray$env)
table1 <- tkwidget(mainmenu,"table",variable=tclArrayName,rows="80",cols="80",titlerows="1",selectmode="extended",colwidth="30",background="white",selectmode="extended",rowseparator="\"\n\"",colseparator="\"\t\"",resizeborders="both",multiline=1,titlerows=1,titlecols=1,height=80,width=80,xscrollcommand=function(...) tkset(xscr,...),yscrollcommand=function(...) tkset(yscr,...))
	xscr <-tkscrollbar(mainmenu,orient="horizontal", command=function(...)tkxview(table1,...))
  	yscr <- tkscrollbar(mainmenu,command=function(...)tkyview(table1,...))

 tkgrid(table1,yscr)
 tkgrid.configure(yscr,sticky="nsw")
 tkgrid(xscr,sticky="new")
  
tclArray[0,0]="Estimated_concentrations_ng_per_ml"
tktitle(mainmenu)="Kinetic operating microarray analyzer: Main menu"
tkraise(mainmenu)
tkfocus(mainmenu)

}

