extractdata_unknown_predict_conc <-
function(workpath,substance){#creates a function with the argument of workpath, Protein of interest and the calibration run
load(paste(gsub("[()/?]","",substance),"forprediction_mean.RData",sep="_"))

times=forprediction$x


stoffcountingindex=1
rawdaten=list()
confdaten=list()

for(substance in substance){


paths=Sys.glob(file.path(workpath, "*")) #creates a list of folders inheriting the timepointsorted data
paths=sort(paths)

a=list()  #creates empty table
b=list()  #creates empty table
neu=list()#creates empty table

foldernames=list.dir(path =paths[1])
progress=1
total=length(foldernames)*length(paths[-(1:3)])
bar=tkProgressBar(title = "This process could take several seconds", min = 0,max = total, width = 500)


#plot the identifikation plot in colours corresponding to the datasets
y=rep(1,length(foldernames))
x=seq(1,length(foldernames))

if(workpath!=wpath || dev.cur()!=2){
if(dev.cur()>2){dev.off()}
windows(title="KOMA: Folders with measured data")
plot(x,y,type="n",pch=4,cex=4,main="Choose folder with data of interest",axes=F,frame=F,xlab="",ylab="")
text(x,y,labels=foldernames ,cex=1)

}
datasets.to.leeve.out=identify(x, y, labels = rep("O",length(x)),col="red", pos = FALSE,n=1, plot = TRUE,offset = 0)

foldernames=foldernames[datasets.to.leeve.out]
Sys.sleep(1)
sampleID.local<<-textstring.entry.window("KOMA: Sample ID","sample ID",sampleID, entryWidth = 50)

for(j in foldernames){                        #first loop to go through the different folders of concentrations
m=1

for(i in paths[-(1:3)]){     #go through timepoints without the first three

setTkProgressBar(bar, progress, label=paste( "Signal data exctraction",round(progress/total*100,0),"% done"))

a[[m]]=(read.table(paste(i,paste(j,"\\result.txt",sep=""),sep="\\"),header=T,sep="\t"))[,-(c(5,6,7))]  #reading the tables and cut of unneccessary columns

analyte=(a[[m]][,2]==substance)

SpotIDs=c(a[[m]][analyte,1])

a[[m]]=a[[m]][,-(c(1))]

a[[m]]=a[[m]][analyte,-(c(2))]

m=m+1
progress=progress+1
}

#go through all the columns an paste rows with equal names together in neu


for(g in 1:length(a[[m-1]][,1])){
neu[[g]]=a[[m-1]][g,]
for(l in 1:length(paths[-(1:3)])){
neu[[g]]=rbind(neu[[g]],a[[l]][g,])
}
neu[[g]]=neu[[g]][-(1),]
}

#whrite the different concentrations together in one list
b[[j]]=neu
}
#################################################################################################################################
#create table usable for plotting and analysis

d=list()  #create empty list

#seperate the list entries to the certain datasets

for(r in 1:length(b[[1]])){
d[[r]]=b[[1]][[r]][,1]
for(s in 1:length(foldernames)){
d[[r]]=cbind(d[[r]],b[[s]][[r]][,2])
}
d[[r]]=d[[r]][,-(1)]

##reflect the table and adjust it to rising concentrations

#d[[r]]=arev(d[[r]],2)


}
close(bar)
#save data list, which inheritate the name of the analytes, the Spot IDs and the rawdata
rawdaten[[stoffcountingindex]]=list("name"=substance,"times"=times,"SpotIDs"=SpotIDs,"rawdata"=d)
#Blub=daten[[stoffcountingindex]]
#save(Blub,file=paste(substance,"rawdata",run,".RData",sep="_"))

a=list()  #creates empty table
b=list()  #creates empty table
neu=list()#creates empty table
progress=1
total=(length(foldernames)*length(paths[-(1:3)]))+1
bar=tkProgressBar(title = "This process could take several seconds", min = 0,max = total, width = 500)



for(j in foldernames){                        #first loop to go through the different folders of concentrations
m=1

for(i in paths[-(1:3)]){     #go through timepoints without the first three

setTkProgressBar(bar, progress, label=paste( "Confidence data exctraction",round(progress/total*100,0),"% done"))

a[[m]]=(read.table(paste(i,paste(j,"\\result.txt",sep=""),sep="\\"),header=T,sep="\t"))[,-(c(5,6,7))]  #reading the tables and cut of unneccessary columns

analyte=(a[[m]][,2]==substance)

SpotIDs=c(a[[m]][analyte,1])

a[[m]]=a[[m]][,-(c(1))]

a[[m]]=a[[m]][analyte,-(c(3))]


m=m+1

progress=progress+1
}


#go through all the columns an paste rows with equal names together in neu


for(g in 1:length(a[[m-1]][,1])){
neu[[g]]=a[[m-1]][g,]
for(l in 1:length(paths[-(1:3)])){
neu[[g]]=rbind(neu[[g]],a[[l]][g,])
}
neu[[g]]=neu[[g]][-(1),]
}

#whrite the different concentrations together in one list
b[[j]]=neu
}
#################################################################################################################################
#create table usable for plotting and analysis

d=list()  #create empty list

#seperate the list entries to the certain datasets

for(r in 1:length(b[[1]])){
d[[r]]=b[[1]][[r]][,1]
for(s in 1:length(foldernames)){
d[[r]]=cbind(d[[r]],b[[s]][[r]][,2])
}
d[[r]]=d[[r]][,-(1)]

##reflect the table and adjust it to rising concentrations

#d[[r]]=arev(d[[r]],2)


}
#save data list, which inheritate the name of the analytes, the Spot IDs and the rawdata
confdaten[[stoffcountingindex]]=list("name"=substance,"times"=times,"SpotIDs"=SpotIDs,"confidence"=d)
#Blub=daten[[stoffcountingindex]]
#save(Blub,file=paste(substance,"rawdata",run,".RData",sep="_"))


setTkProgressBar(bar, progress, label=paste( "Value calculation",round(progress/total*100,0),"% done"))

IDs.to.go.on=plotting.timecourses.and.choose.IDs.manually(rawdaten[[stoffcountingindex]],substance,confdaten[[stoffcountingindex]],workpath,foldernames)


zahl=1
for(column in 1:ncol(as.matrix(rawdaten[[stoffcountingindex]]$rawdata[[1]]))){#go through concentrations
#translate IDs to indices
nochnezahl=1
for(i in 1:length(IDs.to.go.on[[column]])){
if(nochnezahl==1){index=which(rawdaten[[stoffcountingindex]]$SpotIDs==IDs.to.go.on[[column]][i])}else{index=c(index,which(rawdaten[[stoffcountingindex]]$SpotIDs==IDs.to.go.on[[column]][i]))}
nochnezahl=nochnezahl+1
} 
#sum everthing up,build a mean and past it together for a new table 
countingindex=0
for(z in index){
if(countingindex==0){Sum=as.matrix(rawdaten[[stoffcountingindex]]$rawdata[[z]])[,column]}else{Sum=Sum+as.matrix(rawdaten[[stoffcountingindex]]$rawdata[[z]])[,column]}
countingindex=countingindex+1
}  
mean.value.of.index=Sum/countingindex
if(zahl==1){mean.data=mean.value.of.index}else{mean.data=cbind(mean.data,mean.value.of.index)}
zahl=zahl+1
}
#name and save the resulting data and give them back to the user
rawdata.table=list("name"=substance,"times"=times,"data"=mean.data)



 #########################################################################
 #calculate the euklidean distanze for every column
 #########################################################################
 topredictdist=matrix(1,length(rawdata.table$data),1) #create empty matrix
 for(i in 1:ncol(forprediction$z)){
 topredictdist=cbind(topredictdist,((forprediction$z[,i]-rawdata.table$data)^2))}
 topredictdist=topredictdist[,-(1)] 
 topredictmean=matrix(1,1,1) 
 for(i in 1:ncol(topredictdist)){
  topredictmean=cbind(topredictmean,sqrt(sum(topredictdist[,i])))}
 topredictmean=topredictmean[,-(1)]
#predict the unknown concentration and give it out 
 predictedconc=10^(forprediction$y[which.min(topredictmean)])
 
 
 #plot everything together 
if(plot.graph==TRUE){
 open3d()
par3d(cex=1.2)
par3d(font=4)

par3d(windowRect=c(100,100,1000,900))
persp3d(forprediction,
 xlab="Time [min]",
 ylab="Log calibrator conc. [ng/ml]",
 zlab="Signal intensity",
 main=paste("Sample curve/Calibration surface overlay for",substance,sep="  "),
 extrap=T,
 col="green",
size=1.5,
 alpha=0.5,
 front="points",
 back="points",
 axes=F,
 lit=T,
 add=F,
 sub=paste("Estimated concentration =", predictedconc,"[ng/ml]")
 )[axes3d(edges=c('x','y','z'),color="black",size=1.8)]
 plot3d(times
 ,log(predictedconc)/log(10)
 ,rawdata.table$data
 ,col="red"
 ,size=6
 ,add=T)
 zeroline=rep(0,length(times))
 vertical=seq(0,rawdata.table$data[1],length.out=20)
 conc.vertical=rep(log(predictedconc)/log(10),length(vertical))
 time.vertical=rep(0,length(vertical))
 conc.zeroline=rep(log(predictedconc)/log(10),length(zeroline))
 plot3d(time.vertical
 ,conc.vertical
 ,vertical
 ,col="black"
 ,size=6
 ,add=T
 ,type="l")
 plot3d(times
 ,conc.zeroline
 ,zeroline
 ,col="black"
 ,size=6
 ,add=T
 ,type="l")
}
stoffcountingindex=stoffcountingindex+1
}
progress=progress+1
close(bar)
return(predictedconc)
}

