plotting.overlapping.cals <-
function(workpath){
analyte=analyte.choice(analyte.names)#a function with the arguments of workpath, timeseries und concentrationseries
paths=list.files(pattern=paste(gsub("[()/?]","",analyte),"calibration.table",sep="_"))#Sys.glob(file.path(workpath, "*")) #creates a list of folders inheriting the timepointsorted data
print(paths)
#open an dreformat all the objects needed

dataset=list()
krigging=list()
surfaces=list()

#load the files and extract their data
countingindex=1
for(files in paths){
load(files)
dataset[[countingindex]]=calibration.table$data
times=calibration.table$times
concentrations=calibration.table$concentrations
countingindex=countingindex+1
}
a=c(times)
b=c(log(concentrations)/log(10))
#create a 2d grid of times and concentrations
gridmatrix=t(matrix(2,2))
for(i in 1:length(concentrations)){
for(j in 1:length(times)){
gridmatrix=rbind(gridmatrix,cbind(a[j],b[i]))
}
}
gridmatrix=gridmatrix[-(1),]

#set the paramteers fpr the following 3d plots
open3d()
par3d(cex=1.2)
par3d(font=4)
par3d(windowRect=c(100,100,1000,900))
farben=rainbow(length(dataset))


#plot the datasetpoints step by step
for(i in 1:length(dataset)){
if(i==1){persp3d(times,
log(concentrations)/log(10),
dataset[[1]],
main="Raw data of the different calibration replicates",
xlab="Time [min]",
ylab="Log(C) of calibrator [ng/ml]",
zlab="Absorbance",
extrap=T,
col=farben[i],
alpha=0.5,
front="points",
back="points",
size=7,
axes=F,
lit=T,
add=F)[axes3d(edges=c('x','y','z'),color="black",size=1.8)]
}else{
persp3d(times,
log(concentrations)/log(10),
dataset[[i]],
col=farben[i],
alpha=0.5,
front="points",
back="points",
size=7,
add=T)
}
}
windows(title="KOMA: Validation of calibration replicates")
#plot the identifikation plot in colours corresponding to the datasets
y=rep(1,length(dataset))
x=seq(1,length(dataset))
plot(x,y,col=farben,pch=4,cex=4,main="Reject failed calibration replicates by clicking on X",sub="Accept by rightclick->Stop",frame=F,axes=F,ylab="",xlab="")
if(length(x)>1){
	datasets.to.leeve.out=identify(x, y, labels = rep("O",length(x)), pos = FALSE, plot = TRUE,offset = 0,n=(length(x)-1))
	}else{datasets.to.leeve.out=NULL}
dev.off() 
return(datasets.to.leeve.out)#return the choosen datasets for leaving them out of calculation
}

