#################################################################################################################################
#plot timecourses of replicate spots for a certain concentration and choose bad Spot by Kolmogorov-Smirnov test manually
#################################################################################################################################



plotting.timecourses.and.choose.IDs.manually=function(data,substance,confidencevalues,workpath,foldernames){		#creates a functions with the arguments of timeseries, rawdata, Protein of interest, confidencedata)

IDlist=list()													#create an empty list for storing the bad IDs

#search for the data containing the analyte which is suppost to be shown and write the extract the calibrationdata
if(length(data[[1]])>=4){	
	for(i in 1:length(data)){										#go through the data set and search for th on with the correct name
		if(data[[i]]$name==substance){
			count=i
		}
	}

	
farben=rainbow(length(data[[count]]$rawdata))	#creates a colorpalette containing as many colors a Spots are replicated	
times=data[[count]]$times
concentrations=data[[count]]$concentrations
	
#create a graphical interface for choice of bad spot through all concentrations of an analyte	


for(k in 1:ncol(data[[count]]$rawdata[[1]])){						#start the loop for going through the concentrations
calibrationwindow=tktoplevel()	
tktitle(calibrationwindow)="KOMA: Signal validation"
#plot the signalvalues of the replicated Spots
plot1=tkrplot(calibrationwindow, function(){	#par()
						plot(times,data[[count]]$rawdata[[1]][,k],sub=paste("Current analyte concentration is",round(concentrations[k],digits=4),"[ng/ml]"),xlab="Time [min]",ylab="Signal intensity",type="n", main=paste(data[[1]]$name),ylim=c(0,2*max(data[[count]]$rawdata[[1]][,k])))
						for(i in 1:length(data[[count]]$rawdata)){	
							lines(times,data[[count]]$rawdata[[i]][,k],type="l", main=data[[1]]$name,col=farben[i])
							text(x=times[length(times)],y=data[[count]]$rawdata[[i]][length(times),k],labels =data[[count]]$SpotIDs[i],col=farben[i],cex=1.3)
						}
						legend("topleft",legend=data[[count]]$SpotIDs,lty=0,text.col=farben)
					},hscale=1.2, vscale=1.2)
#plot the confidencevalues of the replicated Spots
plot2=tkrplot(calibrationwindow, function(){	
						plot(times,confidencevalues[[count]]$confidence[[1]][,k],xlab="Time [min]",ylab="Confidence values",type="n", main=paste(confidencevalues[[1]]$name),ylim=c(0,2*max(confidencevalues[[count]]$confidence[[1]][,k])))
						for(i in 1:length(confidencevalues[[count]]$confidence)){	
							lines(times,confidencevalues[[count]]$confidence[[i]][,k],type="l",col=farben[i])
							text(x=times[length(times)],y=confidencevalues[[count]]$confidence[[i]][length(times),k],labels =confidencevalues[[count]]$SpotIDs[i],col=farben[i],cex=1.3)
						}
						legend("topleft",legend=data[[count]]$SpotIDs,lty=0,text.col=farben)
					},hscale=1.2, vscale=1.2)
#plot a window for chossing the Spot by clicking on the Xs		
		y=rep(1,length(data[[count]]$SpotIDs))
		x=seq(1,length(data[[count]]$SpotIDs))
					 
#calculate a Kolmogoroc-Smirnov statistics for comparing all the Timecourse with the timecouse of the opposite mean --> how much does the Spot gives impact to the mean of the Spots
		for(i in 1:length(data[[count]]$rawdata)){					#start a loop to go through the Spots
			index=seq(1,length(data[[count]]$rawdata))				#create a index for the number of the Spots
			value.to.compare=data[[count]]$rawdata[[i]][,k]				#choose the Spot to be tested
			others=index[-i]							#choose al the other Spots
			countingindex=0
#sum up the others build a mean out of them	
				for(z in others){
			 		if(countingindex==0){Sum=data[[count]]$rawdata[[z]][,k]}else{Sum=Sum+data[[count]]$rawdata[[z]][,k]}
			 		countingindex=countingindex+1
			 	}
			mean.value.of.the.others=Sum/countingindex
#perform a KS-Test by comparing ech Spot with the mean of the others
			if(i==1){p.for.ID=round(ks.test(value.to.compare,mean.value.of.the.others)$p.value,digits=3)}else{p.for.ID=c(p.for.ID,round(ks.test(value.to.compare,mean.value.of.the.others)$p.value,digits=3))}
		}
		
		
rbValue1=tclVar("0")
rbValue2=tclVar("0")
rbValue3=tclVar("0")
rbValue4=tclVar("0")
rbValue5=tclVar("0")
rbValue6=tclVar("0")

plot3=tkrplot(calibrationwindow,function(){
			IDs.to.left.out=seq(1:6)[c(tclvalue(rbValue1),tclvalue(rbValue2),tclvalue(rbValue3),tclvalue(rbValue4),tclvalue(rbValue5),tclvalue(rbValue6))==0]
			
			index=seq(1,length(data[[count]]$rawdata))				#create a index for the number of the Spots
			others=index[IDs.to.left.out]						#choose all the other Spots
			countingindex=0
	#sum up the others build a mean out of them	
			for(z in others){
			 	if(countingindex==0){Sum=data[[count]]$rawdata[[z]][,k]}else{Sum=Sum+data[[count]]$rawdata[[z]][,k]}
			 	countingindex=countingindex+1
			 }
				mean.value.of.the.others=Sum/countingindex
		
	#perform a KS-Test by comparing ech Spot with the mean of the others
			
		plot(times,mean.value.of.the.others,xlab="Time [min]",ylab="Signal intensity",main="Signal mean",cex.main=0.8,type="l",col="red",ylim=c(0,2*max(data[[count]]$rawdata[[1]][,k])))
	})

replot.mean=function(){
	tkrreplot(plot3)
	tkraise(calibrationwindow)
	tkfocus(calibrationwindow)}
	

rb1=tkcheckbutton(calibrationwindow,background="red")
rb2=tkcheckbutton(calibrationwindow,background="yellow")
rb3=tkcheckbutton(calibrationwindow,background="green")
rb4=tkcheckbutton(calibrationwindow,background="cyan")
rb5=tkcheckbutton(calibrationwindow,background="blue")
rb6=tkcheckbutton(calibrationwindow,background="violet")

tkconfigure(rb1,variable=rbValue1,command=replot.mean)	
tkconfigure(rb2,variable=rbValue2,command=replot.mean)	
tkconfigure(rb3,variable=rbValue3,command=replot.mean)	
tkconfigure(rb4,variable=rbValue4,command=replot.mean)	
tkconfigure(rb5,variable=rbValue5,command=replot.mean)	
tkconfigure(rb6,variable=rbValue6,command=replot.mean)	

tkgrid(plot1,plot2,columnspan=1,rowspan=10)
tkgrid(plot3,column=2,row=0,columnspan=3)
tklabel(calibrationwindow,text=" ")



tkgrid(tklabel(calibrationwindow,text="Please choose spot replicates you want to exclude from further analysis!"),column=2,row=1,columnspan=3)
tkgrid(tklabel(calibrationwindow,text="Spot ID"),column=2,row=2,sticky="nsew")
tkgrid(tklabel(calibrationwindow,text="KS-p-value"),column=4,row=2,sticky="nsew")
tkgrid(tklabel(calibrationwindow,text=paste(data[[count]]$SpotIDs[1])),sticky="nsew",row=3,column=2)
tkgrid(tklabel(calibrationwindow,text=paste(data[[count]]$SpotIDs[2])),sticky="nsew",row=4,column=2)
tkgrid(tklabel(calibrationwindow,text=paste(data[[count]]$SpotIDs[3])),sticky="nsew",row=5,column=2)
tkgrid(tklabel(calibrationwindow,text=paste(data[[count]]$SpotIDs[4])),sticky="nsew",row=6,column=2)
tkgrid(tklabel(calibrationwindow,text=paste(data[[count]]$SpotIDs[5])),sticky="nsew",row=7,column=2)
tkgrid(tklabel(calibrationwindow,text=paste(data[[count]]$SpotIDs[6])),sticky="nsew",row=8,column=2)
tkgrid(tklabel(calibrationwindow,text=paste(p.for.ID[1])),sticky="nsew",row=3,column=4)
tkgrid(tklabel(calibrationwindow,text=paste(p.for.ID[2])),sticky="nsew",row=4,column=4)
tkgrid(tklabel(calibrationwindow,text=paste(p.for.ID[3])),sticky="nsew",row=5,column=4)
tkgrid(tklabel(calibrationwindow,text=paste(p.for.ID[4])),sticky="nsew",row=6,column=4)
tkgrid(tklabel(calibrationwindow,text=paste(p.for.ID[5])),sticky="nsew",row=7,column=4)
tkgrid(tklabel(calibrationwindow,text=paste(p.for.ID[6])),sticky="nsew",row=8,column=4)
tkgrid(rb1,sticky="nsew",row=3,column=3)
tkgrid(rb2,sticky="nsew",row=4,column=3)
tkgrid(rb3,sticky="nsew",row=5,column=3)
tkgrid(rb4,sticky="nsew",row=6,column=3)
tkgrid(rb5,sticky="nsew",row=7,column=3)
tkgrid(rb6,sticky="nsew",row=8,column=3)
tkgrid(tkbutton(calibrationwindow,text="OK",command=function()tkdestroy(calibrationwindow)),column=2,sticky="nsew",columnspan=3)
tkwm.geometry(calibrationwindow,"+0+0")
tkraise(calibrationwindow)
tkfocus(calibrationwindow)
tkwait.window(calibrationwindow)	

	IDs.to.left.out=seq(1:6)[c(tclvalue(rbValue1),tclvalue(rbValue2),tclvalue(rbValue3),tclvalue(rbValue4),tclvalue(rbValue5),tclvalue(rbValue6))==1]
	
#IDs.to.left.out=identify(x, y, labels = rep("O",length(x)), pos = FALSE,n=(length(x)-1), plot = TRUE,offset = 0)
		if(length(IDs.to.left.out)==0){IDs=data[[count]]$SpotIDs}else{IDs=data[[count]]$SpotIDs[-(IDs.to.left.out)]}
#store the choice in the reutrned value of the function
		if(k==1){IDlist[[k]]=IDs}else{IDlist[[k]]=IDs}
}

}else{

	
farben=rainbow(length(data$rawdata))							#creates a colorpalette containing as many colors a Spots are replicated	
times=data$times
concentrations=data$concentrations	
#create a graphical interface for choice of bad spot through all concentrations of an analyte	
if(is.vector(data$rawdata)){
	for(i in 1:length(data$rawdata)){
		data$rawdata[[i]]=as.matrix(data$rawdata[[i]])
	}
}

if(is.vector(confidencevalues$confidence)){
	for(i in 1:length(confidencevalues$confidence)){
		confidencevalues$confidence[[i]]=as.matrix(confidencevalues$confidence[[i]])
	}
}

	for(k in 1:ncol(data$rawdata[[1]])){						#start the loop for going through the concentrations
	calibrationwindow=tktoplevel()	
	tktitle(calibrationwindow)=paste("KOMA: Signal validation for ",paste(workpath,foldernames,sep="\\"))
#plot the signalvalues of the replicated Spots
plot1=tkrplot(calibrationwindow, function(){	
		plot(times,data$rawdata[[1]][,k],xlab="Time [min]",ylab="Signal intensity",type="n", main=paste(data$name),ylim=c(0,2*max(data$rawdata[[1]][,k])))
			for(i in 1:length(data$rawdata)){	
				lines(times,data$rawdata[[i]][,k],type="l", main=data$name,col=farben[i])
				text(x=times[length(times)],y=data$rawdata[[i]][length(times),k],labels =data$SpotIDs[i],col=farben[i],cex=1.3)
				}
		legend("topleft",legend=data$SpotIDs,lty=0,text.col=farben)
			},hscale=1.2, vscale=1.2)
#plot the confidencevalues of the replicated Spots
plot2=tkrplot(calibrationwindow, function(){	
		plot(times,confidencevalues$confidence[[1]][,k],xlab="Time [min]",ylab="Confidence values",type="n", main=paste(confidencevalues$name),ylim=c(0,2*max(confidencevalues$confidence[[1]][,k])))
			for(i in 1:length(confidencevalues$confidence)){	
				lines(times,confidencevalues$confidence[[i]][,k],type="l",col=farben[i])
				text(x=times[length(times)],y=confidencevalues$confidence[[i]][length(times),k],labels =confidencevalues$SpotIDs[i],col=farben[i],cex=1.3)
				}
		legend("topleft",legend=data$SpotIDs,lty=0,text.col=farben)
			},hscale=1.2, vscale=1.2)
#plot a window for chossing the Spot by clicking on the Xs		
		y=rep(1,length(data$SpotIDs))
		x=seq(1,length(data$SpotIDs))
			 
#calculate a Kolmogoroc-Smirnov statistics for comparing all the Timecourse with the timecouse of the opposite mean --> how much does the Spot gives impact to the mean of the Spots
		for(i in 1:length(data$rawdata)){					#start a loop to go through the Spots
			index=seq(1,length(data$rawdata))				#create a index for the number of the Spots
			value.to.compare=data$rawdata[[i]][,k]				#choose the Spot to be tested
			others=index[-i]						#choose all the other Spots
			countingindex=0
#sum up the others build a mean out of them	
				for(z in others){
			 		if(countingindex==0){Sum=data$rawdata[[z]][,k]}else{Sum=Sum+data$rawdata[[z]][,k]}
			 		countingindex=countingindex+1
			 	}
			mean.value.of.the.others=Sum/countingindex
#perform a KS-Test by comparing ech Spot with the mean of the others
			if(i==1){p.for.ID=round(ks.test(value.to.compare,mean.value.of.the.others)$p.value,digits=3)}else{p.for.ID=c(p.for.ID,round(ks.test(value.to.compare,mean.value.of.the.others)$p.value,digits=3))}
		}

#print the calculated values in the plot and let the user choose via indetify, which Spots he want to leave out
rbValue1=tclVar("0")
rbValue2=tclVar("0")
rbValue3=tclVar("0")
rbValue4=tclVar("0")
rbValue5=tclVar("0")
rbValue6=tclVar("0")

plot3=tkrplot(calibrationwindow,function(){
			IDs.to.left.out=seq(1:6)[c(tclvalue(rbValue1),tclvalue(rbValue2),tclvalue(rbValue3),tclvalue(rbValue4),tclvalue(rbValue5),tclvalue(rbValue6))==0]
			
			index=seq(1,length(data$rawdata))				#create a index for the number of the Spots
			others=index[IDs.to.left.out]						#choose all the other Spots
			countingindex=0
	#sum up the others build a mean out of them	
			for(z in others){
			 	if(countingindex==0){Sum=data$rawdata[[z]][,k]}else{Sum=Sum+data$rawdata[[z]][,k]}
			 	countingindex=countingindex+1
			 }
				mean.value.of.the.others=Sum/countingindex
		
	#perform a KS-Test by comparing ech Spot with the mean of the others
			
		plot(times,mean.value.of.the.others,xlab="Time [min]",ylab="Signal intensity",main="Signal mean",cex.main=0.8,type="l",col="red",ylim=c(0,2*max(data$rawdata[[1]][,k])))
	})

replot.mean=function(){
	tkrreplot(plot3)
	tkraise(calibrationwindow)
	tkfocus(calibrationwindow)}
	

rb1=tkcheckbutton(calibrationwindow,background="red")
rb2=tkcheckbutton(calibrationwindow,background="yellow")
rb3=tkcheckbutton(calibrationwindow,background="green")
rb4=tkcheckbutton(calibrationwindow,background="cyan")
rb5=tkcheckbutton(calibrationwindow,background="blue")
rb6=tkcheckbutton(calibrationwindow,background="violet")

tkconfigure(rb1,variable=rbValue1,command=replot.mean)	
tkconfigure(rb2,variable=rbValue2,command=replot.mean)	
tkconfigure(rb3,variable=rbValue3,command=replot.mean)	
tkconfigure(rb4,variable=rbValue4,command=replot.mean)	
tkconfigure(rb5,variable=rbValue5,command=replot.mean)	
tkconfigure(rb6,variable=rbValue6,command=replot.mean)	

tkgrid(plot1,plot2,columnspan=1,rowspan=10)
tkgrid(plot3,column=2,row=0,columnspan=3)
tklabel(calibrationwindow,text=" ")



tkgrid(tklabel(calibrationwindow,text="Please choose spot replicates you want to exclude from further analysis!"),column=2,row=1,columnspan=3)
tkgrid(tklabel(calibrationwindow,text="Spot ID"),column=2,row=2,sticky="nsew")
tkgrid(tklabel(calibrationwindow,text="KS-p-value"),column=4,row=2,sticky="nsew")
tkgrid(tklabel(calibrationwindow,text=paste(data$SpotIDs[1])),sticky="nsew",row=3,column=2)
tkgrid(tklabel(calibrationwindow,text=paste(data$SpotIDs[2])),sticky="nsew",row=4,column=2)
tkgrid(tklabel(calibrationwindow,text=paste(data$SpotIDs[3])),sticky="nsew",row=5,column=2)
tkgrid(tklabel(calibrationwindow,text=paste(data$SpotIDs[4])),sticky="nsew",row=6,column=2)
tkgrid(tklabel(calibrationwindow,text=paste(data$SpotIDs[5])),sticky="nsew",row=7,column=2)
tkgrid(tklabel(calibrationwindow,text=paste(data$SpotIDs[6])),sticky="nsew",row=8,column=2)
tkgrid(tklabel(calibrationwindow,text=paste(p.for.ID[1])),sticky="nsew",row=3,column=4)
tkgrid(tklabel(calibrationwindow,text=paste(p.for.ID[2])),sticky="nsew",row=4,column=4)
tkgrid(tklabel(calibrationwindow,text=paste(p.for.ID[3])),sticky="nsew",row=5,column=4)
tkgrid(tklabel(calibrationwindow,text=paste(p.for.ID[4])),sticky="nsew",row=6,column=4)
tkgrid(tklabel(calibrationwindow,text=paste(p.for.ID[5])),sticky="nsew",row=7,column=4)
tkgrid(tklabel(calibrationwindow,text=paste(p.for.ID[6])),sticky="nsew",row=8,column=4)
tkgrid(rb1,sticky="nsew",row=3,column=3)
tkgrid(rb2,sticky="nsew",row=4,column=3)
tkgrid(rb3,sticky="nsew",row=5,column=3)
tkgrid(rb4,sticky="nsew",row=6,column=3)
tkgrid(rb5,sticky="nsew",row=7,column=3)
tkgrid(rb6,sticky="nsew",row=8,column=3)
tkgrid(tkbutton(calibrationwindow,text="OK",command=function(){	
								tkdestroy(calibrationwindow)
								plot.graph<<-FALSE
								},background="white"),column=2,row=9,sticky="nsew")
tkgrid(tkbutton(calibrationwindow,text="OK and plot the result",command=function(){	
								tkdestroy(calibrationwindow)
								plot.graph<<-TRUE
								},background="white"),column=4,row=9,sticky="nsew")
								
tkwm.geometry(calibrationwindow,"+0+0")
tkraise(calibrationwindow)
tkfocus(calibrationwindow)
tkwait.window(calibrationwindow)	

IDs.to.left.out=seq(1:6)[c(tclvalue(rbValue1),tclvalue(rbValue2),tclvalue(rbValue3),tclvalue(rbValue4),tclvalue(rbValue5),tclvalue(rbValue6))==1]
	
		
		if(length(IDs.to.left.out)==0){IDs=data$SpotIDs}else{IDs=data$SpotIDs[-(IDs.to.left.out)]}
#stor the choice in the reutrned value of the function
		if(k==1){IDlist[[k]]=IDs}else{IDlist[[k]]=IDs}
}


}
	return(IDlist)										#give back the chosen IDs



}

